#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire600one4xi.py">
#<abstract4xi abstract = "fires to direction one and to distance 600"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire600one4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>

# -------------------------------------------------------------------------------------------------
# Global constants                            
# ------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "

       
# -------------------------------------------------------------------------------------------------
# SHOT2ONE - COORDINATE SIGNS OF SHOOT2ONE4XI: (X + ,Y + ,Z + )
# -------------------------------------------------------------------------------------------------  

global shot2one6004xi


#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings - copied from load2one4xi.py results to access faster by verb4xi.py
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False 


# -------------------------------------------------------------------------------------------------
# 600
# -------------------------------------------------------------------------------------------------                                          
shot2one6004xi = {
                  1:'0x0y599z',
                  2:'0x12y599z',
                  3:'0x18y599z',
                  4:'0x397y449z',
                  5:'0x540y261z',
                  6:'0x6y599z',
                  7:'103x542y234z',
                  8:'107x429y404z',
                  9:'109x476y348z',
                  10:'109x517y282z',
                  11:'10x21y599z',
                  12:'10x52y597z',
                  13:'114x351y472z',
                  14:'11x0y599z',
                  15:'11x27y599z',
                  16:'11x46y598z',
                  17:'128x419y409z',
                  18:'12x33y598z',
                  19:'12x40y598z',
                  20:'130x340y476z',
                  21:'131x534y239z',
                  22:'133x466y352z',
                  23:'135x508y288z',
                  24:'146x328y479z',
                  25:'148x408y413z',
                  26:'156x455y357z',
                  27:'158x524y245z',
                  28:'160x498y293z',
                  29:'161x316y483z',
                  30:'168x396y417z',
                  31:'16x458y386z',
                  32:'175x303y487z',
                  33:'178x443y362z',
                  34:'17x0y599z',
                  35:'17x558y217z',
                  36:'184x512y250z',
                  37:'185x486y298z',
                  38:'186x383y422z',
                  39:'188x289y490z',
                  40:'18x14y599z',
                  41:'200x275y493z',
                  42:'200x430y367z',
                  43:'204x369y426z',
                  44:'209x473y303z',
                  45:'20x392y453z',
                  46:'210x500y255z',
                  47:'211x260y497z',
                  48:'220x415y372z',
                  49:'221x245y500z',
                  50:'221x354y430z',
                  51:'22x19y599z',
                  52:'230x230y503z',
                  53:'232x458y308z',
                  54:'235x486y261z',
                  55:'237x338y434z',
                  56:'238x214y507z',
                  57:'240x400y376z',
                  58:'245x198y510z',
                  59:'251x182y513z',
                  60:'251x322y438z',
                  61:'254x443y313z',
                  62:'258x384y381z',
                  63:'259x470y266z',
                  64:'25x24y598z',
                  65:'265x305y443z',
                  66:'276x366y386z',
                  67:'276x426y319z',
                  68:'278x287y447z',
                  69:'27x536y266z',
                  70:'281x454y272z',
                  71:'289x269y451z',
                  72:'28x30y598z',
                  73:'292x349y390z',
                  74:'296x408y324z',
                  75:'299x251y454z',
                  76:'2x71y595z',
                  77:'303x436y277z',
                  78:'307x330y395z',
                  79:'308x232y458z',
                  80:'315x390y329z',
                  81:'316x213y462z',
                  82:'321x311y399z',
                  83:'324x418y282z',
                  84:'332x370y334z',
                  85:'334x291y404z',
                  86:'344x398y288z',
                  87:'346x270y408z',
                  88:'349x350y339z',
                  89:'34x497y333z',
                  90:'356x249y412z',
                  91:'362x377y293z',
                  92:'364x329y344z',
                  93:'36x42y697z',
                  94:'378x307y348z',
                  95:'379x356y298z',
                  96:'391x285y353z',
                  97:'395x333y303z',
                  98:'39x453y391z',
                  99:'3x4y599z',
                  100:'409x310y308z',
                  101:'40x386y457z',
                  102:'46x555y222z',
                  103:'55x531y272z',
                  104:'5x0y599z',
                  105:'5x65y596z',
                  106:'60x378y461z',
                  107:'60x491y338z',
                  108:'62x446y395z',
                  109:'6x10y599z',
                  110:'75x549y228z',
                  111:'78x370y465z',
                  112:'82x525y277z',
                  113:'85x438y400z',
                  114:'85x484y343z',
                  115:'8x15y599z',
                  116:'8x502y328z',
                  117:'8x59y597z',
                  118:'96x361y468z'}

#"
#"/>
    

# -------------------------------------------------------------------------------------------------
#<function4xi function = "fire600one4xi" usage = "target function for chargeone4xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def fire600one4xi(queue2one, consumer_channel2one, publisher_channel2one):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE60ONE4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE60ONE4XI -  QUEUE2ONE: ", queue2one)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE60ONE4XI -  CONSUMER_CHANNEL2ONE: ", consumer_channel2one)
        # 
              
        print("\n (STEP 1A4/33) OF FIRE60ONE4XI -  PUBLISHER_CHANNEL2ONE: ", publisher_channel2one)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE60ONE4XI - TRYING TO RETURN BY PUTTING SHOT2ONE6004XI TO QUEUE2ONE: ", queue2one, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2one.put(shot2one6004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE60ONE4XI - SUCCEEDED TO PUT SHOT2ONE6004XI TO QUEUE2ONE: ", queue2one, " - TIME: ", time4xi()) 
            # SUCCEEDED TO PUT SHOT2ONE6004XI TO QUEUE2ONE:  <queue4xi.Queue4Xi object at 0x02AF7090>  - TIME:  23:45:06 08/24/10 Pacific Daylight Time  
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE60ONE4XI *** FAILED TO PUT SHOT2ONE6004XI TO QUEUE2ONE: ", queue2one, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE60ONE4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2ONE: ", publisher_channel2one, " - TIME: ", time4xi())
        #
         
    if ack2put is True:
        message2send4one = "<ack2put4xi>queue2one8shot2one6004xi</ack2put4xi>"
    else:
        message2send4one = "<nack2put4xi>queue2one8shot2one6004xi</nack2put4xi>" 
                  
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
   
        publisher_channel2one.send(message2send4one)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE60ONE4XI -  SENT MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2ONE: ", publisher_channel2one, " - TIME: ", time4xi()) 
            # SENT MESSAGE2SEND4ONE:  <ack2put4xi>queue2one8shot2one6004xi</ack2put4xi>  TO PUBLISHER_CHANNEL2ONE:  <read-write PipeConnection, handle 260>  - TIME:  23:45:06 08/24/10 Pacific Daylight Time 
        
    except:
        print(" (STEP 3C/33) OF FIRE60ONE4XI *** FAILED TO SEND MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2ONE: ", publisher_channel2one, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE60ONE4XI - RETURNING QUEUE OBJECT QUEUE2ONE: ", queue2one, " - TIME: ", time4xi())  
        # 
            
    return queue2one    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>



# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire600one4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
